#define D1 23 
#define button D1
#define pressed LOW
#include <esp_now.h>
#include <WiFi.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define SCREEN_WIDTH 128
#define SCREEN_HEIGHT 64

Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, -1);

uint8_t broadcastAddress[] = {0x24, 0x0A, 0xC4, 0x9F, 0x4E, 0x6C};
//24:0A:C4:9B:1B:8C
//24:0A:C4:9F:4E:6C

int x;
int y;
int z;

typedef struct open_water {
  int s;
} open_water;

typedef struct from_sensor {
  int H;
  int T; 
  int I;
} temp_set; 

open_water switch_data;
temp_set oled_data;

void insect(){
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(0, 30);
  display.println("warning!! insect");
  display.display();
}

void OnDataSent(const uint8_t *mac_addr, esp_now_send_status_t status) {
  Serial.print("\r\nLast Packet Send Status:\t");
  Serial.println(status == ESP_NOW_SEND_SUCCESS ? "Delivery Success" : "Delivery Fail");
}

void OnDataRecv(const uint8_t * mac_addr, const uint8_t *incomingData, int len) {
  memcpy(&oled_data, incomingData, sizeof(oled_data));
  Serial.print("Huminity : ");
  Serial.println(oled_data.H);
  Serial.print("Temperature : ");
  Serial.println(oled_data.T);
  Serial.println(oled_data.I);
  x = oled_data.H;
  y = oled_data.T;
  z = oled_data.I;
}

void led(){
   if(x<=100 and x>95){
    digitalWrite(18, HIGH); 
    digitalWrite(5, LOW);
    digitalWrite(17, LOW);
    digitalWrite(16, LOW);
    digitalWrite(4, LOW);
    digitalWrite(13, LOW);
    digitalWrite(27, LOW);
    digitalWrite(25, LOW);
    digitalWrite(33, LOW);
    digitalWrite(32, LOW);
  }
  else if(x<=95 and x>90){
    digitalWrite(18, HIGH); 
    digitalWrite(5, HIGH);
    digitalWrite(17, LOW);
    digitalWrite(16, LOW);
    digitalWrite(4, LOW);
    digitalWrite(13, LOW);
    digitalWrite(27, LOW);
    digitalWrite(25, LOW);
    digitalWrite(33, LOW);
    digitalWrite(32, LOW);
  }
  else if(x<=90 and x>85){
    digitalWrite(18, HIGH); 
    digitalWrite(5, HIGH);
    digitalWrite(17, HIGH);
    digitalWrite(16, LOW);
    digitalWrite(4, LOW);
    digitalWrite(13, LOW);
    digitalWrite(27, LOW);
    digitalWrite(25, LOW);
    digitalWrite(33, LOW);
    digitalWrite(32, LOW);
  }
  else if(x<=85 and x>80){
    digitalWrite(18, HIGH); 
    digitalWrite(5, HIGH);
    digitalWrite(17, HIGH);
    digitalWrite(16, HIGH);
    digitalWrite(4, LOW);
    digitalWrite(13, LOW);
    digitalWrite(27, LOW);
    digitalWrite(25, LOW);
    digitalWrite(33, LOW);
    digitalWrite(32, LOW);
  }
  else if(x<=80 and x>75){
    digitalWrite(18, HIGH); 
    digitalWrite(5, HIGH);
    digitalWrite(17, HIGH);
    digitalWrite(16, HIGH);
    digitalWrite(4, HIGH);
    digitalWrite(13, LOW);
    digitalWrite(27, LOW);
    digitalWrite(25, LOW);
    digitalWrite(33, LOW);
    digitalWrite(32, LOW);
  }
  else if(x<=75 and x>70){
    digitalWrite(18, HIGH); 
    digitalWrite(5, HIGH);
    digitalWrite(17, HIGH);
    digitalWrite(16, HIGH);
    digitalWrite(4, HIGH);
    digitalWrite(13, HIGH);
    digitalWrite(27, LOW);
    digitalWrite(25, LOW);
    digitalWrite(33, LOW);
    digitalWrite(32, LOW);
  }
  else if(x<=70 and x>65){
    digitalWrite(18, HIGH); 
    digitalWrite(5, HIGH);
    digitalWrite(17, HIGH);
    digitalWrite(16, HIGH);
    digitalWrite(4, HIGH);
    digitalWrite(13, HIGH);
    digitalWrite(27, HIGH);
    digitalWrite(25, LOW);
    digitalWrite(33, LOW);
    digitalWrite(32, LOW);
  }
  else if(x<=65 and x>60){
    digitalWrite(18, HIGH); 
    digitalWrite(5, HIGH);
    digitalWrite(17, HIGH);
    digitalWrite(16, HIGH);
    digitalWrite(4, HIGH);
    digitalWrite(13, HIGH);
    digitalWrite(27, HIGH);
    digitalWrite(25, HIGH);
    digitalWrite(33, LOW);
    digitalWrite(32, LOW);
  }
  else if(x<=60 and x>55){
    digitalWrite(18, HIGH); 
    digitalWrite(5, HIGH);
    digitalWrite(17, HIGH);
    digitalWrite(16, HIGH);
    digitalWrite(4, HIGH);
    digitalWrite(13, HIGH);
    digitalWrite(27, HIGH);
    digitalWrite(25, HIGH);
    digitalWrite(33, HIGH);
    digitalWrite(32, LOW);
  }
  else {
    digitalWrite(18, HIGH); 
    digitalWrite(5, HIGH);
    digitalWrite(17, HIGH);
    digitalWrite(16, HIGH);
    digitalWrite(4, HIGH);
    digitalWrite(13, HIGH);
    digitalWrite(27, HIGH);
    digitalWrite(25, HIGH);
    digitalWrite(33, HIGH);
    digitalWrite(32, HIGH);
  }
}

void oled(){
    display.clearDisplay();
    display.setTextSize(1);
    display.setTextColor(WHITE);
    display.setCursor(0, 0);
    display.print("Huminity : ");
    display.println(x);
    display.print("Temperature : ");
    display.println(y); 
    display.display(); 
}

void setup() 
{
  Serial.begin(115200);
  WiFi.mode(WIFI_STA);
  if (esp_now_init() != ESP_OK) {
    Serial.println("Error initializing ESP-NOW");
    return;
  }
  if(!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) { 
    Serial.println(F("SSD1306 allocation failed"));
    for(;;);
  }
  esp_now_register_recv_cb(OnDataRecv);
  esp_now_register_send_cb(OnDataSent);

  esp_now_peer_info_t peerInfo;
  memcpy(peerInfo.peer_addr, broadcastAddress, 6);
  peerInfo.channel = 0;  
  peerInfo.encrypt = false;
         
  if (esp_now_add_peer(&peerInfo) != ESP_OK){
    Serial.println("Failed to add peer");
    return;
  }
  
  if(!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) { // Address 0x3D for 128x64
    Serial.println(F("SSD1306 allocation failed"));
    for(;;);
  }    
  
  pinMode(18, OUTPUT);
  pinMode(5, OUTPUT);
  pinMode(17, OUTPUT);
  pinMode(16, OUTPUT);
  pinMode(4, OUTPUT);
  pinMode(13, OUTPUT);
  pinMode(27, OUTPUT);
  pinMode(25, OUTPUT);
  pinMode(33, OUTPUT);
  pinMode(32, OUTPUT);
  
  pinMode(button,INPUT_PULLUP);
}

void loop() 
{  
  bool ReadSwitch = digitalRead(button);
  if(ReadSwitch == pressed)
  { 
    switch_data.s = 1;
    esp_err_t result = esp_now_send   (broadcastAddress, (uint8_t *) &switch_data, sizeof(switch_data));
    Serial.println("Pressed Switch.");
    if (result == ESP_OK) {
      Serial.println("Sent with success");
    }
    else {
      Serial.println("Error sending the data");
    }
    delay(4000);
  }
  oled();
  led();
  if(z == 1){
    insect();  
  }
}
