#include <WiFi.h>
#include <esp_now.h>

int Humidity = 36;
int Temperature =  34;
int Pump = 23;
int Temp_value;
int Humidity_value ;

uint8_t broadcastAddress[] = {0x30, 0xAE, 0xA4, 0x8D, 0x85, 0x64};


typedef struct struct_message {
  int a;
  int b;
  int c;
} struct_message;


typedef struct Proud{
  int s;
}Proud;


struct_message Data;
Proud Waterfall;



void OnDataSent(const uint8_t *mac_addr, esp_now_send_status_t status) {
  if (Humidity_value < 60){
    digitalWrite(Pump, LOW);
   }
  Serial.print("\r\nLast Packet Send Status:\t");
  Serial.println(status == ESP_NOW_SEND_SUCCESS ? "Delivery Success" : "Delivery Fail");
}

void OnDataRecv(const uint8_t * mac_addr, const uint8_t *incomingData, int len) {
 memcpy(&Waterfall, incomingData, sizeof(Waterfall));
 Serial.print("Status : ");
 Serial.println(Waterfall.s);
 if (Waterfall.s == 1 ){
    digitalWrite(Pump, HIGH);
 }
 
}
 
void setup() {
  Serial.begin(115200);
  WiFi.mode(WIFI_STA);

  pinMode(Temperature,INPUT);
  pinMode(Humidity,INPUT);
  pinMode(Pump,OUTPUT);
  
  
  if (esp_now_init() != ESP_OK) {
    Serial.println("Error initializing ESP-NOW");
    return;
  }

  esp_now_register_send_cb(OnDataSent);
  esp_now_register_recv_cb(OnDataRecv);
  
  esp_now_peer_info_t peerInfo;
  memcpy(peerInfo.peer_addr, broadcastAddress, 6);
  peerInfo.channel = 0;  
  peerInfo.encrypt = false;
        
  if (esp_now_add_peer(&peerInfo) != ESP_OK){
    Serial.println("Failed to add peer");
    return;
  }
}
 
void loop() {
  Humidity_value = analogRead(Humidity);
  Temp_value = analogRead(Temperature);
  Temp_value = map(Temp_value,1900,2200,20,40);
  Humidity_value = map(Humidity_value,0,4095,25,100);
  Data.a =  Humidity_value;
  Data.b =  Temp_value;
  Data.c = 0;
 

  esp_err_t result = esp_now_send(broadcastAddress, (uint8_t *) &Data, sizeof(Data));

   
  if (result == ESP_OK) {
    Serial.println("Sent with success");
  }
  else {
    Serial.println("Error sending the data");
  }
  delay(4000);
}
